#!/bin/bash

#repertoire d'installation de postgresql
postgres=/usr/local/pgsql
xlog=$postgres/data/pg_xlog/

#repertoire ou sont sauvegarder les fichier WAL
backup_dir=/home/postgres/WAL/

#fichier de log
log=./backup.log

dat=`date '+%m-%d-%g_%H-%M'`

echo "=====================" >> $log
echo "BACKUP $dat" >> $log
echo "=====================" >> $log
echo >> $log

#lancement de la requete qui indique le debut du backup au serveur psql
echo -n "Starting backup at " >> $log
date >> $log
echo "select pg_start_backup('$dat')" | psql -U postgres template1 >> $log



#sauvegarde des fichier de base de donnes
echo -n "Starting tar at " >> $log
date >> $log
tar -cjf backup_$dat.tar.bz2 $postgres/data --exclude pg_xlog > /dev/null



#indique a la DB que le backup des fichier est finis
echo -n "End backup at " >> $log
date >> $log
echo "select pg_stop_backup()" | psql -U postgres template1 >> $log


#recherche du dernier fihcier WAL utiliser
echo -n "Deleting old WAL file " >> $log
date >> $log
backup=0
for dir in $xlog*.backup
do
  file=${dir:${#xlog}:24}
  if [ -f $dir ] ; then
    let "tmp = 0x$file"
    if (( $tmp > $backup )) ; then
        #echo "old backup: $backup and new backup: $tmp"
      backup=$tmp
    fi
  fi
done

#Suppression des fichiers WAL devenus inutile
for dir in $backup_dir*
do
  file=${dir:${#backup_dir}:24}
  if [ -f $dir ] ; then
  let "hex  = 0x$file"
    #echo "$dir=>$backup"
    if (( $hex < $backup )) ; then
      echo "delete file $dir" >> $log
      rm $dir
    fi
  fi
done

echo -n "End of backup script " >> $log
date >> $log
echo >> $log
echo >> $log
